-- Do not edit.  Generated by cheby 1.7.dev0 using these options:
--  --header commit --gen-hdl si5340_ctrl_map.vhd --gen-c ../../sw/hw-include/si5340_ctrl_map.h -i si5340_ctrl_map.cheby


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.wishbone_pkg.all;

entity si5340_ctrl_map is
  port (
    rst_n_i              : in    std_logic;
    clk_i                : in    std_logic;
    wb_i                 : in    t_wishbone_slave_in;
    wb_o                 : out   t_wishbone_slave_out;

    -- Control register
    -- Enable SPI control (and disable the core)
    ctrl_spi_en_o        : out   std_logic;
    -- Enable DAC control (and disable the core)
    ctrl_dac_en_o        : out   std_logic;
    -- Select helper clock (0: wr_clk_helper, 1: dco)
    ctrl_helper_sel_o    : out   std_logic;
    -- Program the DAC
    ctrl_dac_update_o    : out   std_logic;
    -- Enable pll 0 update on input
    ctrl_en0_o           : out   std_logic;
    -- Enable pll 1 update on input
    ctrl_en1_o           : out   std_logic;
    -- Update pll 0 using the force value
    ctrl_force0_o        : out   std_logic;
    -- Update pll 1 using the force value
    ctrl_force1_o        : out   std_logic;

    -- Status register
    -- Update in progress for pll 0
    status_upd0_i        : in    std_logic;
    -- Update in progress for pll 1
    status_upd1_i        : in    std_logic;

    -- dac value (to be set at start)
    pll_0_dac_o          : out   std_logic_vector(31 downto 0);

    -- bias (value = bias + input * mul)
    pll_0_bias_h_o       : out   std_logic_vector(31 downto 0);

    -- Bias low word
    pll_0_bias_l_o       : out   std_logic_vector(31 downto 0);

    -- factor
    pll_0_mul_o          : out   std_logic_vector(31 downto 0);

    -- input value from wr core
    pll_0_inp_i          : in    std_logic_vector(31 downto 0);

    -- forced value
    pll_0_force_o        : out   std_logic_vector(31 downto 0);

    -- current computed value
    pll_0_value_h_i      : in    std_logic_vector(31 downto 0);

    -- current computed value
    pll_0_value_l_i      : in    std_logic_vector(31 downto 0);

    -- dac value (to be set at start)
    pll_1_dac_o          : out   std_logic_vector(31 downto 0);

    -- bias (value = bias + input * mul)
    pll_1_bias_h_o       : out   std_logic_vector(31 downto 0);

    -- Bias low word
    pll_1_bias_l_o       : out   std_logic_vector(31 downto 0);

    -- factor
    pll_1_mul_o          : out   std_logic_vector(31 downto 0);

    -- input value from wr core
    pll_1_inp_i          : in    std_logic_vector(31 downto 0);

    -- forced value
    pll_1_force_o        : out   std_logic_vector(31 downto 0);

    -- current computed value
    pll_1_value_h_i      : in    std_logic_vector(31 downto 0);

    -- current computed value
    pll_1_value_l_i      : in    std_logic_vector(31 downto 0)
  );
end si5340_ctrl_map;

architecture syn of si5340_ctrl_map is
  signal adr_int                        : std_logic_vector(6 downto 2);
  signal rd_req_int                     : std_logic;
  signal wr_req_int                     : std_logic;
  signal rd_ack_int                     : std_logic;
  signal wr_ack_int                     : std_logic;
  signal wb_en                          : std_logic;
  signal ack_int                        : std_logic;
  signal wb_rip                         : std_logic;
  signal wb_wip                         : std_logic;
  signal ctrl_spi_en_reg                : std_logic;
  signal ctrl_dac_en_reg                : std_logic;
  signal ctrl_helper_sel_reg            : std_logic;
  signal ctrl_dac_update_reg            : std_logic;
  signal ctrl_en0_reg                   : std_logic;
  signal ctrl_en1_reg                   : std_logic;
  signal ctrl_force0_reg                : std_logic;
  signal ctrl_force1_reg                : std_logic;
  signal ctrl_wreq                      : std_logic;
  signal ctrl_wack                      : std_logic;
  signal pll_0_dac_reg                  : std_logic_vector(31 downto 0);
  signal pll_0_dac_wreq                 : std_logic;
  signal pll_0_dac_wack                 : std_logic;
  signal pll_0_bias_h_reg               : std_logic_vector(31 downto 0);
  signal pll_0_bias_h_wreq              : std_logic;
  signal pll_0_bias_h_wack              : std_logic;
  signal pll_0_bias_l_reg               : std_logic_vector(31 downto 0);
  signal pll_0_bias_l_wreq              : std_logic;
  signal pll_0_bias_l_wack              : std_logic;
  signal pll_0_mul_reg                  : std_logic_vector(31 downto 0);
  signal pll_0_mul_wreq                 : std_logic;
  signal pll_0_mul_wack                 : std_logic;
  signal pll_0_force_reg                : std_logic_vector(31 downto 0);
  signal pll_0_force_wreq               : std_logic;
  signal pll_0_force_wack               : std_logic;
  signal pll_1_dac_reg                  : std_logic_vector(31 downto 0);
  signal pll_1_dac_wreq                 : std_logic;
  signal pll_1_dac_wack                 : std_logic;
  signal pll_1_bias_h_reg               : std_logic_vector(31 downto 0);
  signal pll_1_bias_h_wreq              : std_logic;
  signal pll_1_bias_h_wack              : std_logic;
  signal pll_1_bias_l_reg               : std_logic_vector(31 downto 0);
  signal pll_1_bias_l_wreq              : std_logic;
  signal pll_1_bias_l_wack              : std_logic;
  signal pll_1_mul_reg                  : std_logic_vector(31 downto 0);
  signal pll_1_mul_wreq                 : std_logic;
  signal pll_1_mul_wack                 : std_logic;
  signal pll_1_force_reg                : std_logic_vector(31 downto 0);
  signal pll_1_force_wreq               : std_logic;
  signal pll_1_force_wack               : std_logic;
  signal rd_ack_d0                      : std_logic;
  signal rd_dat_d0                      : std_logic_vector(31 downto 0);
  signal wr_req_d0                      : std_logic;
  signal wr_adr_d0                      : std_logic_vector(6 downto 2);
  signal wr_dat_d0                      : std_logic_vector(31 downto 0);
begin

  -- WB decode signals
  adr_int <= wb_i.adr(6 downto 2);
  wb_en <= wb_i.cyc and wb_i.stb;

  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wb_rip <= '0';
      else
        wb_rip <= (wb_rip or (wb_en and not wb_i.we)) and not rd_ack_int;
      end if;
    end if;
  end process;
  rd_req_int <= (wb_en and not wb_i.we) and not wb_rip;

  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wb_wip <= '0';
      else
        wb_wip <= (wb_wip or (wb_en and wb_i.we)) and not wr_ack_int;
      end if;
    end if;
  end process;
  wr_req_int <= (wb_en and wb_i.we) and not wb_wip;

  ack_int <= rd_ack_int or wr_ack_int;
  wb_o.ack <= ack_int;
  wb_o.stall <= not ack_int and wb_en;
  wb_o.rty <= '0';
  wb_o.err <= '0';

  -- pipelining for wr-in+rd-out
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        rd_ack_int <= '0';
        wb_o.dat <= "00000000000000000000000000000000";
        wr_req_d0 <= '0';
        wr_adr_d0 <= "00000";
        wr_dat_d0 <= "00000000000000000000000000000000";
      else
        rd_ack_int <= rd_ack_d0;
        wb_o.dat <= rd_dat_d0;
        wr_req_d0 <= wr_req_int;
        wr_adr_d0 <= adr_int;
        wr_dat_d0 <= wb_i.dat;
      end if;
    end if;
  end process;

  -- Register ctrl
  ctrl_spi_en_o <= ctrl_spi_en_reg;
  ctrl_dac_en_o <= ctrl_dac_en_reg;
  ctrl_helper_sel_o <= ctrl_helper_sel_reg;
  ctrl_dac_update_o <= ctrl_dac_update_reg;
  ctrl_en0_o <= ctrl_en0_reg;
  ctrl_en1_o <= ctrl_en1_reg;
  ctrl_force0_o <= ctrl_force0_reg;
  ctrl_force1_o <= ctrl_force1_reg;
  ctrl_wack <= ctrl_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        ctrl_spi_en_reg <= '0';
        ctrl_dac_en_reg <= '0';
        ctrl_helper_sel_reg <= '0';
        ctrl_dac_update_reg <= '0';
        ctrl_en0_reg <= '0';
        ctrl_en1_reg <= '0';
        ctrl_force0_reg <= '0';
        ctrl_force1_reg <= '0';
      else
        if ctrl_wreq = '1' then
          ctrl_spi_en_reg <= wr_dat_d0(0);
          ctrl_dac_en_reg <= wr_dat_d0(1);
          ctrl_helper_sel_reg <= wr_dat_d0(2);
          ctrl_dac_update_reg <= wr_dat_d0(3);
          ctrl_en0_reg <= wr_dat_d0(4);
          ctrl_en1_reg <= wr_dat_d0(5);
          ctrl_force0_reg <= wr_dat_d0(6);
          ctrl_force1_reg <= wr_dat_d0(7);
        else
          ctrl_dac_update_reg <= '0';
          ctrl_force0_reg <= '0';
          ctrl_force1_reg <= '0';
        end if;
      end if;
    end if;
  end process;

  -- Register status

  -- Register pll_0_dac
  pll_0_dac_o <= pll_0_dac_reg;
  pll_0_dac_wack <= pll_0_dac_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        pll_0_dac_reg <= "00000000000000000000000000000000";
      else
        if pll_0_dac_wreq = '1' then
          pll_0_dac_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register pll_0_bias_h
  pll_0_bias_h_o <= pll_0_bias_h_reg;
  pll_0_bias_h_wack <= pll_0_bias_h_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        pll_0_bias_h_reg <= "00000000000000000000000000000000";
      else
        if pll_0_bias_h_wreq = '1' then
          pll_0_bias_h_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register pll_0_bias_l
  pll_0_bias_l_o <= pll_0_bias_l_reg;
  pll_0_bias_l_wack <= pll_0_bias_l_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        pll_0_bias_l_reg <= "00000000000000000000000000000000";
      else
        if pll_0_bias_l_wreq = '1' then
          pll_0_bias_l_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register pll_0_mul
  pll_0_mul_o <= pll_0_mul_reg;
  pll_0_mul_wack <= pll_0_mul_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        pll_0_mul_reg <= "00000000000000000000000000000000";
      else
        if pll_0_mul_wreq = '1' then
          pll_0_mul_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register pll_0_inp

  -- Register pll_0_force
  pll_0_force_o <= pll_0_force_reg;
  pll_0_force_wack <= pll_0_force_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        pll_0_force_reg <= "00000000000000000000000000000000";
      else
        if pll_0_force_wreq = '1' then
          pll_0_force_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register pll_0_value_h

  -- Register pll_0_value_l

  -- Register pll_1_dac
  pll_1_dac_o <= pll_1_dac_reg;
  pll_1_dac_wack <= pll_1_dac_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        pll_1_dac_reg <= "00000000000000000000000000000000";
      else
        if pll_1_dac_wreq = '1' then
          pll_1_dac_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register pll_1_bias_h
  pll_1_bias_h_o <= pll_1_bias_h_reg;
  pll_1_bias_h_wack <= pll_1_bias_h_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        pll_1_bias_h_reg <= "00000000000000000000000000000000";
      else
        if pll_1_bias_h_wreq = '1' then
          pll_1_bias_h_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register pll_1_bias_l
  pll_1_bias_l_o <= pll_1_bias_l_reg;
  pll_1_bias_l_wack <= pll_1_bias_l_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        pll_1_bias_l_reg <= "00000000000000000000000000000000";
      else
        if pll_1_bias_l_wreq = '1' then
          pll_1_bias_l_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register pll_1_mul
  pll_1_mul_o <= pll_1_mul_reg;
  pll_1_mul_wack <= pll_1_mul_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        pll_1_mul_reg <= "00000000000000000000000000000000";
      else
        if pll_1_mul_wreq = '1' then
          pll_1_mul_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register pll_1_inp

  -- Register pll_1_force
  pll_1_force_o <= pll_1_force_reg;
  pll_1_force_wack <= pll_1_force_wreq;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        pll_1_force_reg <= "00000000000000000000000000000000";
      else
        if pll_1_force_wreq = '1' then
          pll_1_force_reg <= wr_dat_d0;
        end if;
      end if;
    end if;
  end process;

  -- Register pll_1_value_h

  -- Register pll_1_value_l

  -- Process for write requests.
  process (wr_adr_d0, wr_req_d0, ctrl_wack, pll_0_dac_wack, pll_0_bias_h_wack,
           pll_0_bias_l_wack, pll_0_mul_wack, pll_0_force_wack, pll_1_dac_wack,
           pll_1_bias_h_wack, pll_1_bias_l_wack, pll_1_mul_wack,
           pll_1_force_wack) begin
    ctrl_wreq <= '0';
    pll_0_dac_wreq <= '0';
    pll_0_bias_h_wreq <= '0';
    pll_0_bias_l_wreq <= '0';
    pll_0_mul_wreq <= '0';
    pll_0_force_wreq <= '0';
    pll_1_dac_wreq <= '0';
    pll_1_bias_h_wreq <= '0';
    pll_1_bias_l_wreq <= '0';
    pll_1_mul_wreq <= '0';
    pll_1_force_wreq <= '0';
    case wr_adr_d0(6 downto 2) is
    when "00000" =>
      -- Reg ctrl
      ctrl_wreq <= wr_req_d0;
      wr_ack_int <= ctrl_wack;
    when "00001" =>
      -- Reg status
      wr_ack_int <= wr_req_d0;
    when "10000" =>
      -- Reg pll_0_dac
      pll_0_dac_wreq <= wr_req_d0;
      wr_ack_int <= pll_0_dac_wack;
    when "10001" =>
      -- Reg pll_0_bias_h
      pll_0_bias_h_wreq <= wr_req_d0;
      wr_ack_int <= pll_0_bias_h_wack;
    when "10010" =>
      -- Reg pll_0_bias_l
      pll_0_bias_l_wreq <= wr_req_d0;
      wr_ack_int <= pll_0_bias_l_wack;
    when "10011" =>
      -- Reg pll_0_mul
      pll_0_mul_wreq <= wr_req_d0;
      wr_ack_int <= pll_0_mul_wack;
    when "10100" =>
      -- Reg pll_0_inp
      wr_ack_int <= wr_req_d0;
    when "10101" =>
      -- Reg pll_0_force
      pll_0_force_wreq <= wr_req_d0;
      wr_ack_int <= pll_0_force_wack;
    when "10110" =>
      -- Reg pll_0_value_h
      wr_ack_int <= wr_req_d0;
    when "10111" =>
      -- Reg pll_0_value_l
      wr_ack_int <= wr_req_d0;
    when "11000" =>
      -- Reg pll_1_dac
      pll_1_dac_wreq <= wr_req_d0;
      wr_ack_int <= pll_1_dac_wack;
    when "11001" =>
      -- Reg pll_1_bias_h
      pll_1_bias_h_wreq <= wr_req_d0;
      wr_ack_int <= pll_1_bias_h_wack;
    when "11010" =>
      -- Reg pll_1_bias_l
      pll_1_bias_l_wreq <= wr_req_d0;
      wr_ack_int <= pll_1_bias_l_wack;
    when "11011" =>
      -- Reg pll_1_mul
      pll_1_mul_wreq <= wr_req_d0;
      wr_ack_int <= pll_1_mul_wack;
    when "11100" =>
      -- Reg pll_1_inp
      wr_ack_int <= wr_req_d0;
    when "11101" =>
      -- Reg pll_1_force
      pll_1_force_wreq <= wr_req_d0;
      wr_ack_int <= pll_1_force_wack;
    when "11110" =>
      -- Reg pll_1_value_h
      wr_ack_int <= wr_req_d0;
    when "11111" =>
      -- Reg pll_1_value_l
      wr_ack_int <= wr_req_d0;
    when others =>
      wr_ack_int <= wr_req_d0;
    end case;
  end process;

  -- Process for read requests.
  process (adr_int, rd_req_int, ctrl_spi_en_reg, ctrl_dac_en_reg,
           ctrl_helper_sel_reg, ctrl_en0_reg, ctrl_en1_reg, status_upd0_i,
           status_upd1_i, pll_0_dac_reg, pll_0_bias_h_reg, pll_0_bias_l_reg,
           pll_0_mul_reg, pll_0_inp_i, pll_0_force_reg, pll_0_value_h_i,
           pll_0_value_l_i, pll_1_dac_reg, pll_1_bias_h_reg, pll_1_bias_l_reg,
           pll_1_mul_reg, pll_1_inp_i, pll_1_force_reg, pll_1_value_h_i,
           pll_1_value_l_i) begin
    -- By default ack read requests
    rd_dat_d0 <= (others => 'X');
    case adr_int(6 downto 2) is
    when "00000" =>
      -- Reg ctrl
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0(0) <= ctrl_spi_en_reg;
      rd_dat_d0(1) <= ctrl_dac_en_reg;
      rd_dat_d0(2) <= ctrl_helper_sel_reg;
      rd_dat_d0(3) <= '0';
      rd_dat_d0(4) <= ctrl_en0_reg;
      rd_dat_d0(5) <= ctrl_en1_reg;
      rd_dat_d0(6) <= '0';
      rd_dat_d0(7) <= '0';
      rd_dat_d0(31 downto 8) <= (others => '0');
    when "00001" =>
      -- Reg status
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0(0) <= status_upd0_i;
      rd_dat_d0(1) <= status_upd1_i;
      rd_dat_d0(31 downto 2) <= (others => '0');
    when "10000" =>
      -- Reg pll_0_dac
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= pll_0_dac_reg;
    when "10001" =>
      -- Reg pll_0_bias_h
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= pll_0_bias_h_reg;
    when "10010" =>
      -- Reg pll_0_bias_l
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= pll_0_bias_l_reg;
    when "10011" =>
      -- Reg pll_0_mul
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= pll_0_mul_reg;
    when "10100" =>
      -- Reg pll_0_inp
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= pll_0_inp_i;
    when "10101" =>
      -- Reg pll_0_force
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= pll_0_force_reg;
    when "10110" =>
      -- Reg pll_0_value_h
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= pll_0_value_h_i;
    when "10111" =>
      -- Reg pll_0_value_l
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= pll_0_value_l_i;
    when "11000" =>
      -- Reg pll_1_dac
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= pll_1_dac_reg;
    when "11001" =>
      -- Reg pll_1_bias_h
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= pll_1_bias_h_reg;
    when "11010" =>
      -- Reg pll_1_bias_l
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= pll_1_bias_l_reg;
    when "11011" =>
      -- Reg pll_1_mul
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= pll_1_mul_reg;
    when "11100" =>
      -- Reg pll_1_inp
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= pll_1_inp_i;
    when "11101" =>
      -- Reg pll_1_force
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= pll_1_force_reg;
    when "11110" =>
      -- Reg pll_1_value_h
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= pll_1_value_h_i;
    when "11111" =>
      -- Reg pll_1_value_l
      rd_ack_d0 <= rd_req_int;
      rd_dat_d0 <= pll_1_value_l_i;
    when others =>
      rd_ack_d0 <= rd_req_int;
    end case;
  end process;
end syn;
